
// ==UserScript==
// @name           Add Link
// @description    Insert links for embedded objects.
// @include        *
// ==/UserScript==

OFFICIAL_SCHEME = "(aaas|aaa|acap|afs|cap|cid|crid|data|dav|dict|dns|dtn|fax|file|ftp|gopher|go|h323|https|http|iax2|icap|imap|im|info|ipp|iris\\.beep|iris\\.lwz|iris\\.xpcs|iris\\.xpc|iris|ldap|mailserver|mailto|mid|modem|msrps|msrp|mtqp|mupdate|news|nfs|nntp|opaquelocktoken|pack|pop|pres|prospero|rtsp|service|shttp|sips|sip|snmp|soap\\.beeps|soap\\.beep|tag|telnet|tel|tftp|thismessage|tip|tn3270|tv|urn|vemmi|wais|xmlrpc\\.beeps|xmlrpc\\.beep|xmpp|z39\\.50r|z39\\.50s)";
UNOFFICIAL_SCHEME = "(about|addbook|afp|aim|applescript|bcp|bk|btspp|callto|castanet|cdv|chrome|chttp|cvs|daytime|device|doi|ed2k|eid|enp|feed|finger|fish|freenet|gg|gizmoproject|gsiftp|gsm-sms|h324|hdl|hnews|httpsy|iioploc|ilu|IOR|ircs|irc|itms|jar|javascript|jdbc|klik|kn|lastfm|ldaps|lifn|livescript|lrq|magnet|mailbox|man|md5|mms|mocha|moz-abmdbdirectory|msnim|myim|notes|nsfw|oai|pcast|phone|php|pop3|printer|psyc|pyimp|rdar|res|rsync|rvp|rwhois|rx|sdp|secondlife|sftp|skype|smb|sms|snews|soap\\.udp|soldat|ssh|steam|SubEthaEdit|svn\\+ssh|svn|t120|tann|tcp|telephone|txmt|uddi|unreal|ut2004|uuid|videotex|view-source|wcap|webcal|whodp|whois\\+\\+|whois|wpn|wtai|xeerkat|xfire|ymsgr)";
const SCHEME = "(" + OFFICIAL_SCHEME + "|" + UNOFFICIAL_SCHEME + "):";
const IP_LITERAL = "(\\[((([a-f\\d]{1,4}:){6}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(::([a-f\\d]{1,4}:){5}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(([a-f\\d]{1,4})?::([a-f\\d]{1,4}:){4}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|((([a-f\\d]{1,4}:)?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){3}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,2})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){2}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,3})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,4})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,5})?[a-f\\d]{1,4})?::[a-f\\d]{1,4})|(((([a-f\\d]{1,4}:){1,6})?[a-f\\d]{1,4})?::))\\])";
const IPV4ADDRESS = "((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5]))";
const IP = "(" + IP_LITERAL + "|" + IPV4ADDRESS + ")";
const HIER_PART = "(((\\/\\/)?((([\\w-.~!$&'()*+,;=:]|%[a-f\\d]{2})*@)?(" + IP + "|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5]))|([\\w-.~!$&'()*+,;=]|%[a-f\\d]{2})*)(:\\d+)?))([\\w-.~!$&'()*+,;=:@/]|%[a-f\\d]{2})*)";
const QUERY_FRAGMENT = "([&?]([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?(#([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?";
const URI = "(" + SCHEME + HIER_PART + QUERY_FRAGMENT + ")";

const TAGS =
{
	"embed": "src",
	"object": "data"
};

function main()
{
	appendStyle(".addlink-table {border: 0 ! important; border-collapse: separate ! important; margin: 0 auto ! important; width: 0 ! important;} .addlink-table td {border: 0 ! important; padding: 0 ! important; margin: 0 2.5px 0 2.5px ! important;}");
	var elements = document.evaluate(".//embed[@src and not(parent::object)] | .//object[@data or child::embed]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (elements && elements.snapshotLength > 0) for (var i = 0; i < elements.snapshotLength; i++)
	{
		var element = elements.snapshotItem(i);
		element.setAttribute("style", "position: relative;");
		var embObj = element;

		var divInnner = "<table class=\"addlink-table\" align=center border=0 cellspacing=5 cellpadding=0><tbody><tr style=\"text-align: left ! important; vertical-align: baseline ! important;\">";

		var tagName = element.tagName.toLowerCase();
		var value = element.getAttribute(TAGS[tagName]);

		var idHideShow = "addlink-object-hideShow" + i;
		var idScale = "addlink-object-scale" + i;
		element.setAttribute("id", idHideShow);

		if (tagName == "object")
		{
			var embeds = document.evaluate("./embed", element, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			if (embeds && embeds.snapshotLength > 0)
			{
				var embed = embeds.snapshotItem(0);
				if (!value) value = embed.getAttribute(TAGS["embed"]);
				embed.setAttribute("id", idScale);
				embed.setAttribute("style", "position: relative;");
				embObj = embed;
			}
			else idScale = idHideShow;
		}
		else idScale = idHideShow;

		divInnner += "<td><a href=\"" + value + "\" title=\"Add Link: " + value + "\">Link</a>";

		var matches = getOuterHTML(element).match(new RegExp(URI, "gi"));
		if (matches && matches.snapshotLength > 0)
		{
			var count = 1;
			for (var i = 0; i < matches.length; i++)
				if (matches[i] != value) divInnner += "<a href=\"" + matches[i] + "\" title=\"Add Link: " + matches[i] + "\">&nbsp;[" + count++ + "]</a>";
		}

		divInnner += "</td>";

		var hasInnerObj = idScale != idHideShow;
		var hasWidthOrHeight = embObj.width > 0 || embObj.height > 0;
		if (hasInnerObj) hasWidthOrHeight = hasWidthOrHeight || element.width > 0 || element.height > 0;

		var funcScale = null;
		if (hasWidthOrHeight)
		{
			funcScale = "(function(){var select=document.addlinkForm" + i + ".addlinkSelect;var index=select.selectedIndex;var scale=select.options[index].text;var embObj=document.getElementById('" + idScale + "');embObj.width=" + (embObj.width > 0 && embObj.width < 800 ? embObj.width : 480) + "*scale;embObj.height=" + (embObj.height > 0 && embObj.height < 600 ? embObj.height : 360) + "*scale;";
			if (hasInnerObj) funcScale += "embObj=document.getElementById('" + idHideShow + "');embObj.width=" + (element.width > 0 && element.width < 800 ? element.width : 480) + "*scale;embObj.height=" + (element.height > 0 && element.height < 600 ? element.height : 360) + "*scale;";
			funcScale += "}());";
		}

		var funcHide = "(function(){document.getElementById('addlink-show" + i + "').setAttribute('style','');document.getElementById('addlink-hide" + i + "').setAttribute('style','display:none!important;');document.getElementById('" + idHideShow + "').setAttribute('style','display:none!important;');}());"
		var funcShow = "(function(){document.getElementById('addlink-hide" + i + "').setAttribute('style','');document.getElementById('addlink-show" + i + "').setAttribute('style','display:none!important;');document.getElementById('" + idHideShow + "').setAttribute('style','');}());";

		if (hasWidthOrHeight) divInnner +=
			"<td><!--label for=\"addlink-scale"+i+"\">Scale:</label-->"+
			"<form id=\"addlink-scale"+i+"\" name=\"addlinkForm"+i+"\" title=\"Add Link: Scale\">"+
			"<select name=\"addlinkSelect\" onclick=\"" + funcScale + funcShow + "\">"+
			"<option value=\"0.5\">0.5</option>"+
			"<option value=\"0.6\">0.6</option>"+
			"<option value=\"0.7\">0.7</option>"+
			"<option value=\"0.8\">0.8</option>"+
			"<option value=\"0.9\">0.9</option>"+
			"<option value=\"1.0\" selected=\"selected\">1.0</option>"+
			"<option value=\"1.1\">1.1</option>"+
			"<option value=\"1.2\">1.2</option>"+
			"<option value=\"1.3\">1.3</option>"+
			"<option value=\"1.4\">1.4</option>"+
			"<option value=\"1.5\">1.5</option>"+
			"</select>"+
			"</form></td>"; // SCALE
		divInnner += "<td><a id=\"addlink-hide" + i + "\" href=\"javascript:" + funcHide + "\" title=\"Add Link: Hide\">Hide</a>"; // HIDE
		divInnner += "<a id=\"addlink-show" + i + "\" href=\"javascript:" + funcShow + "\" style=\"display: none ! important;\" title=\"Add Link: Show\">Show</a></td>"; // SHOW

		var div = document.createElement("div");
		div.setAttribute("style", "display: block ! important; overflow: hidden ! important; padding: 5px ! important; position: relative;");
		div.innerHTML = divInnner;
		element.parentNode.insertBefore(div, element.nextSibling);

		eval(funcShow);
	}
}

function getOuterHTML(node) {
	var outerHTML = "";
	switch (node.nodeType) {
	case 1: // element-node
		outerHTML += "<" + node.nodeName;
		for (var i in node.attributes) {
			var item = node.attributes.item(i);
			outerHTML += " " + item.nodeName + "=";
			outerHTML += "\"" + item.nodeValue + "\"";
		}
		if (node.childNodes.length == 0) outerHTML += " />";
		else {
			outerHTML += ">";
			outerHTML += node.innerHTML;
			outerHTML += "</" + node.nodeName + ">"
		}
		break;
	}
	return outerHTML;
}

function appendStyle(css)
{
	var head = document.getElementsByTagName("head")[0];
	if (!head) return;
	var style = document.createElement("style");
	style.rel = "stylesheet";
	style.type = "text/css";
	style.innerHTML = css;
	head.appendChild(style);
}

main();

