
// ==UserScript==
// @name           Prevent Third
// @description    Remove/hide third-party resources.
// @include        *
// ==/UserScript==

/*
 *	Home:      http://userscripts.org/scripts/show/13825
 *	ChangeLog: http://userscripts.org/scripts/show/13825
 */

const SCHEME = /^(aaa|aaas|acap|afs|cap|cid|crid|data|dav|dict|dns|dtn|fax|file|ftp|go|gopher|h323|http|https|iax2|icap|im|imap|info|ipp|iris|iris.beep|iris.lwz|iris.xpc|iris.xpcs|ldap|mailserver|mailto|mid|modem|msrp|msrps|mtqp|mupdate|news|nfs|nntp|opaquelocktoken|pack|pop|pres|prospero|rtsp|service|shttp|sip|sips|snmp|soap.beep|soap.beeps|tag|tel|telnet|tftp|thismessage|tip|tn3270|tv|urn|vemmi|wais|xmlrpc.beep|xmlrpc.beeps|xmpp|z39.50r|z39.50s):/i;
const DOMAIN = /((\[((([a-f0-9]{1,4}:){6}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(::([a-f0-9]{1,4}:){5}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(([a-f0-9]{1,4})?::([a-f0-9]{1,4}:){4}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|((([a-f0-9]{1,4}:)?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:){3}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,2})?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:){2}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,3})?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,4})?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,5})?[a-f0-9]{1,4})?::[a-f0-9]{1,4})|(((([a-f0-9]{1,4}:){1,6})?[a-f0-9]{1,4})?::))\])|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])|([a-z0-9-_~!$&'()*+,;=]|%[a-f0-9]{2})*\.([a-z0-9-_~!$&'()*+,;=]|%[a-f0-9]{2})*)$/i;
const TAGS =
{
	"applet": "codebase",
	"area": "href",
	"embed": "src",
	"iframe": "src",
	"img": "src",
	"input": "src",
	"object": "data",
	"param": "value"
};

function main()
{
	var domain = window.location.hostname.match(DOMAIN);
	if (!domain) return;

	var expression = "";
	var isFirst = true;
	for (var tag in TAGS)
	{
		if (isFirst) isFirst = false;
		else expression += " | ";
		expression += ".//" + tag + "[@" + TAGS[tag] + " and not(contains(@" + TAGS[tag] + ", '" + domain[0] + "'))]";
	}

	var elements = document.evaluate(expression, document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	for (var i = 0; i < elements.snapshotLength; i++)
	{
		var element = elements.snapshotItem(i);
		var attribute = TAGS[element.tagName.toLowerCase()];
//		if (element.getAttribute(TAGS[element.tagName.toLowerCase()]).match(SCHEME)) element.style.display = "none";
		if (element.getAttribute(TAGS[element.tagName.toLowerCase()]).match(SCHEME)) element.parentNode.removeChild(element);
	}
}

main();

