
// ==UserScript==
// @name           Text to Link
// @description    Change URIs and non-URIs written as text into links.
// @include        *
// ==/UserScript==

/*
<h2>Links</h2><pre>Home:      http://userscripts.org/scripts/show/7122
Changelog: http://text-to-link-userscript.blogspot.com
</pre>

<h2>Changelog</h2><pre>2007-04-03  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (URI, ILLEGAL, ..): Renamed a few things.
(ILLEGAL): Changed a few tags in the ILLEGAL variable that didn't make
sense.

2007-08-24  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (URI): Extended the regular expression.

2007-09-11  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (path-abempty): The segment needed the 0-* operator for
the pchar non-terminal.
(UNWANTED): Added a regular expression to sort out
unwanted results from the uri regex. An example is a
scheme-only-uri { FAQ: | Changelog: | ... }.
  It was not a problem of false-positives, but I agree that there is no
meaning in transforming URIs with only a scheme.
Thanks to `sharmard' (http://userscripts.org/scripts/show/7122?page=2#comment-17680)

2007-09-16  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (textToLink): Added the parameter `text'. Now when the
index > 0 the element.nodeValue is not checked for matches
{ILLEGAL, URI, ...}. This gives an increase in performance.
(ILLEGAL, elements): Removed variable ILLEGAL and added its information
to the XPath expression.

2007-11-11  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (textToLink): Transform a bracket-encapsulated URL
without the closing-bracket.
Thanks to `bobielawlintine' (http://userscripts.org/scripts/show/7122#comment-22323)

2007-11-17  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (*): An attempt to `linkify' non-urls which fulfill some
requirements (REQUISITE).
Thanks again to `bobielawlintine' (http://userscripts.org/scripts/show/7122#comment-22852)

2007-11-18  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (URI, HOST): Reduced the language of the top-level domain
in part 2. This helps to transform non-uris which are separated by comma
single quotation or punctuation marks. Simply, it brings back some false
negatives.

2007-11-18  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (MAILTO, TEL): Checking for common non-url pattern,
adding a protocol to it.
(textToLink): Append a `https' link additionally to an unknown non-url
pattern (http + https).
(appendStyle): Show a icon for `mailto', `http' and `https' links.
(checkTime): If the script runs for a certain amount of time it will ask
to continue. The following run time will be a little longer.

2007-11-20  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (document.evaluate): Changed in the xpath-expression the
parent to be ancestor (whoops).

2007-11-21  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (*): No need anymore for the HOST and REQUISITE regular
expressions, the URI does the whole job.
(URI) Using special characters (\d = [0-9], \w = [A-Za-z0-9_]) in the
regex. Shortens the regex a little.

2007-11-23  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (URI): Disassembled the uri with the help of strings. The
highlighting looks better this way :)
(*): Using the RegExp class/object to create regular expressions.
(textToLink*): Introducing a textToLinkRabbit (for contentType
text/html, application/xhtml+xml) and textToLinkTurtle (for everything
else) version of the textToLink function. One is fast and one is slower,
due to the use of JavaScript/strings (fast) and DOM/objects (slower).
Let me know if this can be done better especially when it comes to *.txt
files.
(unwantedRegExp): Added the IPv4address to the unwantedRegExp. It's too
common (fx. version-numbers are transformed into links). If you want it
to be included you can remove it from `unwantedRegExp'.
Thanks to `Bruno 'ReX' Barbieri' (http://userscripts.org/scripts/show/7122#comment-23588)

2007-11-25  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (uriRegExp): Changed the `uriRegExp' to not search
globally (even its faster) in a string for the occurrence of an uri.
There could be hidden another uri after `fixBalanced' has done its job.
(main): Using `document.normalize()' to merge all adjacent text nodes
and remove empty ones.
(checkTime): Made the message better explanatory.
(function textToLink): Got rid of the ~Rabbit and ~Turtle version of
the textToLink function. When encountering a site of contentType
`text/plain' it's simply changed to `text/html' and run again.

2007-11-26  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (UNOFFICIAL_SCHEME): Added some - but surely not all -
unofficial schemes.
(main): Needed to encode `&lt;' and `&gt;' before transforming a text file
into a html document.
(fixBalanced, removeUnwanted, unwantedRegExp): Changed
the order of fixing/removing symbols and checking with the
`unwantedRegExp'. This helps getting rid of some false positives. Added
the symbols `?' and `#' to the `removeUnwanted' function. Also added a
`?' to the `unwantedRegExp', that takes care of only-schemes without
`:'.
Thanks again to `bobielawlintine' (http://userscripts.org/scripts/show/7122#comment-23722)

2007-12-06  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (AUTO_STOP): Added a variable `AUTO_STOP' which when set
to `false' will ask to continue the script. Set it to `true' if you
don't want the question to pop up (search for `const AUTO_STOP').
Thanks to `matrixik' (http://userscripts.org/scripts/show/7122#comment-24543)

2007-12-11  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (main): Commented out the appendStyle calls which inserts
images for common schemes. Also forgot to encode `&lt;' and `&gt;' in
`text/html' and `application/xhtml+xml' documents. Now it works.

2007-12-13  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (main): Removed `;' from `AUTHORITY' and 'REG_NAME' in the
`URI - NO SCHEME'. This makes a non-uri more restrictive and gets rid of
some false positives. It's probably going to be even more restrictive in the
future. Also added `&amp;' to the encoding-process so that HTML entities are
being displayed correctly.
(fixBalanced, removeUnwanted): Extended the functions to also handle strings
additionally to only symbols. Know they can handle HTML entities and suchlike.
(appendStyle): Removed this function.
(checkTime): Removed this function. Instead use the
`dom.max_chrome_script_run_time' preference in Firefox or something similar.
(http://kb.mozillazine.org/Dom.max_chrome_script_run_time)
Also Check this one out: `dom.max_script_run_time'
(http://kb.mozillazine.org/Dom.max_script_run_time)

2007-12-15  Kim A. Brandt &lt;kimabrandt@gmx.de&gt;
* 7122.user.js (main): In case of a contentType `text/plain' the function
`textToLink' is now called, the content replaced by a html document and then
ignored the second time the browser loads the new content.
* 7122.user.js (textToLink): Relocated the replace statement where [&lt;&gt;&amp;] are
replaced by their HTML entety counterpart.
</pre>

<h2>Resources</h2><pre>Uniform Resource Identifier (URI): Generic Syntax
Appendix A.  Collected ABNF for URI
http://tools.ietf.org/html/rfc3986#appendix-A

The mailto URL scheme
2. Syntax of a mailto URL
http://tools.ietf.org/html/rfc2368#section-2

The tel URI for Telephone Numbers
3.  URI Syntax
http://tools.ietf.org/html/rfc3966#section-3

Uniform Resource Identifer (URI) Schemes
http://www.iana.org/assignments/uri-schemes.html

URI scheme
http://en.wikipedia.org/wiki/URI_scheme

UriSchemes
http://esw.w3.org/topic/UriSchemes/

IANA TLD List
http://data.iana.org/TLD/tlds-alpha-by-domain.txt
</pre>
*/

/*
Home:      http://userscripts.org/scripts/show/7122
Changelog: http://text-to-link-userscript.blogspot.com
*/

/*	URI - GENERIC
 */
OFFICIAL_SCHEME = "(aaas|aaa|acap|afs|cap|cid|crid|data|dav|dict|dns|dtn|fax|file|ftp|gopher|go|h323|https|http|iax2|icap|imap|im|info|ipp|iris\\.beep|iris\\.lwz|iris\\.xpcs|iris\\.xpc|iris|ldap|mailserver|mailto|mid|modem|msrps|msrp|mtqp|mupdate|news|nfs|nntp|opaquelocktoken|pack|pop|pres|prospero|rtsp|service|shttp|sips|sip|snmp|soap\\.beeps|soap\\.beep|tag|telnet|tel|tftp|thismessage|tip|tn3270|tv|urn|vemmi|wais|xmlrpc\\.beeps|xmlrpc\\.beep|xmpp|z39\\.50r|z39\\.50s)";
UNOFFICIAL_SCHEME = "(about|addbook|afp|aim|applescript|bcp|bk|btspp|callto|castanet|cdv|chrome|chttp|cvs|daytime|device|doi|ed2k|eid|enp|feed|finger|fish|freenet|gg|gizmoproject|gsiftp|gsm-sms|h324|hdl|hnews|httpsy|iioploc|ilu|IOR|ircs|irc|itms|jar|javascript|jdbc|klik|kn|lastfm|ldaps|lifn|livescript|lrq|magnet|mailbox|man|md5|mms|mocha|moz-abmdbdirectory|msnim|myim|notes|nsfw|oai|pcast|phone|php|pop3|printer|psyc|pyimp|rdar|res|rsync|rvp|rwhois|rx|sdp|secondlife|sftp|skype|smb|sms|snews|soap\\.udp|soldat|ssh|steam|SubEthaEdit|svn\\+ssh|svn|t120|tann|tcp|telephone|txmt|uddi|unreal|ut2004|uuid|videotex|view-source|wcap|webcal|whodp|whois\\+\\+|whois|wpn|wtai|xeerkat|xfire|ymsgr)";
const SCHEME = "(" + OFFICIAL_SCHEME + "|" + UNOFFICIAL_SCHEME + "):";
const IP_LITERAL = "(\\[((([a-f\\d]{1,4}:){6}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(::([a-f\\d]{1,4}:){5}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(([a-f\\d]{1,4})?::([a-f\\d]{1,4}:){4}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|((([a-f\\d]{1,4}:)?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){3}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,2})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){2}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,3})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,4})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,5})?[a-f\\d]{1,4})?::[a-f\\d]{1,4})|(((([a-f\\d]{1,4}:){1,6})?[a-f\\d]{1,4})?::))\\])";
const IPV4ADDRESS = "((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5]))";
const IP = "(" + IPV4ADDRESS + "|" + IP_LITERAL + ")";
const HIER_PART = "(((\\/\\/)?((([\\w-.~!$&'()*+,;=:]|%[a-f\\d]{2})*@)?(" + IP + "|([\\w-.~!$&'()*+,;=]|%[a-f\\d]{2})*)(:\\d+)?))([\\w-.~!$&'()*+,;=:@/]|%[a-f\\d]{2})*)";
const QUERY_FRAGMENT = "([&?]([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?(#([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?";
const URI1 = "(" + SCHEME + HIER_PART + QUERY_FRAGMENT + ")";

/*	URI - NO SCHEME, SPECIFIC REG-NAME AND TOP-LEVEL DOMAIN
 */
const AUTHORITY = "([a-z\\d]([\\w-.~!$&'()*+,=:]|%[a-f\\d]{2})*@)?";
const REG_NAME = "([a-z\\d]([\\w-~!$&'*+,=@]|%[a-f\\d]{2})+\\.)+";
const TLD = "(ac|ad|aero|ae|af|ag|ai|al|am|an|ao|aq|arpa|ar|asia|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|biz|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|cat|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|coop|com|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|info|int|in|io|iq|ir|is|it|je|jm|jobs|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mil|mk|ml|mm|mn|mobi|mo|mp|mq|mr|ms|mt|museum|mu|mv|mw|mx|my|mz|name|na|nc|net|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pro|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tel|tf|tg|th|tj|tk|tl|tm|tn|to|tp|travel|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|xn--0zwm56d|xn--11b5bs3a9aj6g|xn--80akhbyknj4f|xn--9t4b11yi5a|xn--deba0ad|xn--g6w251d|xn--hgbk6aj7f53bba|xn--hlcj6aya9esc7a|xn--jxalpdlp|xn--kgbechtv|xn--zckzah|ye|yt|yu|za|zm|zw)";
const PATH = "([;/]([\\w-.~!$&'()*+,;=:@/]|%[a-f\\d]{2})*)?";
const URI2 = "(" + AUTHORITY + "(" + IP + "|(" + REG_NAME + TLD + "\\b))(:\\d+)?" + PATH + QUERY_FRAGMENT + ")";

/*	PHONENUMBER REGULAR EXPRESSION
 */
const TEL = "((\\+[-.()\\d]*\\d[-.()\\d]*((;[a-z\\d-]+(=([\\w\\[\\]/:&+$-.!~*'()]|%[a-f\\d]{2})+)?)|(;ext=[-.()\\d]+)|(;isub=([\\w;/?:@&=+$,-.!~*'()]|%[a-f\\d]{2})+))*)|([a-f\\d*#-.()]*[a-f\\d*#][a-f\\d*#-.()]*((;[a-z\\d-]+(=(\\w[\\[\\]/:&+$-.!~*'()]|%[a-f\\d]{2})+)?)|(;ext=[-.()\\d]+)|(;isub=([\\w;/?:@&=+$,-.!~*'()]|%[a-f\\d]{2})+))*;phone-context=((([a-z\\d]|([a-z\\d][a-z\\d-]*[a-z\\d]\\.))*([a-z]|([a-z][a-z\\d-]*[a-z\\d]\\.?)))|(\\+[-.()\\d]*\\d[-.()\\d]*))((;[a-z\\d-]+(=([\\w\\[\\]/:&+$-.!~*'()]|%[a-f\\d]{2})+)?)|(;ext=[-.()\\d]+)|(;isub=([\\w;/?:@&=+$,-.!~*'()]|%[a-f\\d]{2})+))*))";
var telRegExp = new RegExp("^" + TEL + "$", "i");

/*	URI REGULAR EXPRESSION
 */
var uriRegExp = new RegExp(URI1 + "|" + URI2 + "|" + TEL, "i");

/*	UNWANTED REGULAR EXPRESSION
 */
const unwantedRegExp = new RegExp("^((" + SCHEME + "?\\/*)|(\\+[-.()\\d]{1,2})|" + IPV4ADDRESS + ")$", "i"); // SCHEME-ONLY OR 1-2 DIGITS PHONENUMBER

/*	MAILTO REGULAR EXPRESSION
 */
const MAILTO = "((([\\w-.~]|%[a-f\\d]{2})+@([\\w-.~,]|%[a-f\\d]{2})+)*([&?]([\\w-.~=@]|%[a-f\\d]{2})*)*)";
var mailtoRegExp = new RegExp("^" + MAILTO + "$", "i");

/*	SCHEME REGULAR EXPRESSION
 */
var schemeRegExp = new RegExp("^" + SCHEME, "i");

function main()
{
	if (document.getElementById("text-to-link-userscript")) return;
//dump("textToLink: start timer...\n");
//var t0 = new Date().getTime();

	document.normalize();
	var elements = document.evaluate(".//text()[not(ancestor::a) and not(ancestor::button) and not(ancestor::label) and not(ancestor::legend) and not(ancestor::option) and not(ancestor::script) and not(ancestor::select) and not(ancestor::style) and not(ancestor::textarea) and not(ancestor::title)]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (!elements || elements.snapshotLength == 0) return;
	switch (document.contentType)
	{
		case "text/html":
		case "application/xhtml+xml":
			for (var i = 0; i < elements.snapshotLength; i++)
			{
				var element = elements.snapshotItem(i);
				var nodeValue = textToLink(element.nodeValue);
				if (!nodeValue) continue;

				var span = document.createElement("span");
				span.innerHTML = nodeValue;
				element.parentNode.replaceChild(span, element);
			}
			break;
		case "text/plain":
			var nodeValue = textToLink(elements.snapshotItem(0).nodeValue);
			if (!nodeValue) return;

			document.open();
			document.write("<html><body><pre id=\"text-to-link-userscript\">" + nodeValue + "</pre></body></html>");
			document.close();
			break;
		default: return;
	}

//dump("textToLink: timer=" + ((new Date().getTime() - t0) / 1000.0) + "\n");
}

function textToLink(nodeValue)
{
	var changesMade = false;
	nodeValue = nodeValue.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;");

	var matches = null;
	var fromIndex = 0;
	while (matches = nodeValue.substring(fromIndex).match(uriRegExp))
	{
		var text = matches[0];
		var index = nodeValue.indexOf(text, fromIndex);
		var leftStr = nodeValue.substring(0, index);
		text = fixBalanced(text, leftStr);
		text = removeUnwanted(text);
		fromIndex = index + text.length;
//dump("text: " + text + "\n");

		if (text.match(unwantedRegExp)) continue;

		var link = nodeValue.substring(index, index + text.length);
		if (!link.match(schemeRegExp))
		{
			if (link.match(mailtoRegExp)) link = "mailto:" + link;
			else if (link.match(telRegExp)) link = "tel:" + link;
			else link = "http://" + link;
		}

		var anchor = "<a href=\"" + link + "\">" + text + "</a>";
		nodeValue = leftStr + anchor + nodeValue.substring(fromIndex);
		fromIndex = index + anchor.length;
		changesMade = true;
	}

	if (!changesMade) return null;
	else return nodeValue;
}

/*	MAXIMUM LENGTH OF LEFT STRING
 *	"&amp;laquo;".length = 11
 */
const MAX_LEFT_STR = 11;
function fixBalanced(text, leftStr)
{
	var index = -1;
	switch (leftStr.charAt(leftStr.length - 1))
	{
		case "(": index = text.indexOf(")"); break;					// (  )
		case "`": index = text.indexOf("'"); break;					// `  '
		case "'": index = text.indexOf("'"); break;					// '  '
	}
	if (index > -1) return text.substring(0, index);
	leftStr = leftStr.substring(leftStr.length - MAX_LEFT_STR);
	if (leftStr.search(/&lt;$/) > -1) index = text.indexOf("&gt;");				// <  >
	else if (leftStr.search(/&amp;lt;$/) > -1) index = text.indexOf("&amp;gt;");		// <  >
	else if (leftStr.search(/&amp;#60;$/) > -1) index = text.indexOf("&amp;#62;");		// <  >
	else if (leftStr.search(/&amp;quot;$/) > -1) index = text.indexOf("&amp;quot;");	// "  "
	else if (leftStr.search(/&amp;#34;$/) > -1) index = text.indexOf("&amp;#34;");		// "  "
	else if (leftStr.search(/&amp;#96;$/) > -1) index = text.indexOf("'");			// `  '
	else if (leftStr.search(/&amp;laquo;$/) > -1) index = text.indexOf("&amp;raquo;");	// «  »
	else if (leftStr.search(/&amp;#171;$/) > -1) index = text.indexOf("&amp;#187;");	// «  »
	if (index > -1) return text.substring(0, index);
	return text;
}

function removeUnwanted(text)
{
	if (text.charAt(text.length - 1).match(/[-~=_,;:!?.(@$*&#]/)) return removeUnwanted(text.substring(0, text.length - 1));
	var index = text.search(/&lt;/); // <
	if (index > -1) return removeUnwanted(text.substring(0, index));
	return text;
}

main();
